"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toRequireContextString = exports.toRequireContext = void 0;

var _coreCommon = require("@storybook/core-common");

const toRequireContext = specifier => {
  const {
    directory,
    files
  } = specifier; // The importPathMatcher is a `./`-prefixed matcher that includes the directory
  // For `require.context()` we want the same thing, relative to directory

  const match = (0, _coreCommon.globToRegexp)(`./${files}`);
  return {
    path: directory,
    recursive: files.includes('**') || files.split('/').length > 1,
    match
  };
};

exports.toRequireContext = toRequireContext;

const toRequireContextString = specifier => {
  const {
    path: p,
    recursive: r,
    match: m
  } = toRequireContext(specifier);
  const result = `require.context('${p}', ${r}, ${m})`;
  return result;
};

exports.toRequireContextString = toRequireContextString;